room(kitchen). 
room(office). 
room(hall). 
room('dining room'). 
room(cellar).

door(office, hall). 
door(kitchen, office). 
door(hall, 'dining room'). 
door(kitchen, cellar). 
door('dining room', kitchen).

location(desk, office). 
location(apple, kitchen). 
location(flashlight, desk). 
location('washing machine', cellar). 
location(nani, 'washing machine'). 
location(broccoli, kitchen). 
location(crackers, kitchen). 
location(computer, office).

location(envelope, desk). 
location(stamp, envelope). 
location(key, envelope).

here(kitchen). 


connect(X,Y) :- door(X,Y). 
connect(X,Y) :- door(Y,X).

move(Place):- 
       retract(here(X)), 
       asserta(here(Place)).

can_go(Place):- 
       here(X), 
       connect(X, Place).

goto(Place):- 
       can_go(Place), 
       move(Place).

% A partir de aqui estan las nuevas funciones

take(Object) :-
       retract(location(Object,X)),
       asserta(have(Object)).
       
can_take(Object):- 
       here(X), 
       location(Object, X).
       
coger(Object):-
       can_take(Object),
       take(Object).

dejar(Object):-
       retract(have(Object)),
       here(X),
       asserta(location(Object,X)).

       