%Calcular height(Tree,Height) tal que Height es la altura del arbol. Se puede definir como el mximo de la altura de sus ramas.
%Tree del tipo -> [[], a, [] ]

max(X, Y, X) :- X > Y.
max(X, Y, Y) :- X < Y.
max(X, Y, Y) :- X = Y.

% 2 Soluciones encontradas:

% Primera solucin:

height1([], 0).
height1([X, Y, Z], H) :- height1(X, H2), A is H2+1, height1(Z, H3), B is H3+1, max(A, B, H).

% Probar con:
% height1([ [[], c, []] , a, [[[], d, []], b, []]], H)
% height1([[], a, []], H)
% Que daran 1 y 3 respectivamente


% Segunda solucin:

height2([], A, A).
height2([X, Y, Z], H, N) :- H2 is H+1, height2(X, H2, N1), height2(Z, H2, N2), max(N1, N2, N).

% Probar con:
% height2([ [[], c, []] , a, [[[], d, []], b, []]], 0, N)
% height2([[], a, []], 0, N)
% Que daran 1 y 3 respectivamente


