 %6. Dada una base de datos con las siguientes caractersticas: 
 %                                       vuelo(NRO,ORIGEN,DESTINO,HORA_P,HORA_LL,avion(MARCA,EDAD)) 
%
 %    Elabore reglas de inferencia para: 
%
 %       a.Indicar si hay vuelo directo entre dos ciudades. 
 %       b.Dada una ciudad, obtener la informacin de los vuelos que salen de ella. 
 %       c.Dado un vuelo, indicar la ciudad de partida y de llegada. 
 %       d.Dados un origen y un destino indicar slo una ruta posible que tenga una escala.   <-- SOLO 1, NO PONER FAIL
 %       e.Indicar los pares de ciudades que estn conectadas con vuelos en ambos sentidos.  


vuelo(1, barcelona, usa, '5:00', '12:00', avion(iberia, 5)).
vuelo(2, usa, barcelona, '12:30', 19:30, avion(iberia, 5)).
vuelo(5, barcelona, madrid, '15:00', '16:00', avion(jump, 3)).
vuelo(3, reus, paris, '8:00', '11:30', avion(british, 2)).
vuelo(4, paris, reus, '12:00', '15:30', avion(british, 2)).
vuelo(6, madrid, cuba, '21:15', '6:00', avion(fly, 1)).
vuelo(7, usa, cuba, '1:15', '3:00', avion(air, 3)).
vuelo(7, cuba, caribe, '2:15', '3:00', avion(air, 4)).

directo(X, Y) :- vuelo(Z, X, Y, HP, HLL, A).
info(X) :- vuelo(Z, X, Y, HP, HLL, avion(A, E)), write('Vuelo con destino '), write(Y), write(' salida '), write(HP), write(' llegada '), write(HLL), write(' avion '), write(A),nl,fail.
numero(X) :- vuelo(X, Y, Z, HP, HLL, A), write('Origen '), write(Y), write(', Destino '), write(Z), nl,fail.
ruta(X, Y) :- vuelo(Z1, X, Z, HP1, HLL1, A1), vuelo(Z2, Z, Y, HP2, HLL2, A2), write(X), write('->'),write(Z), write('->'),write(Y),nl.
ambos_sentidos :- vuelo(Z1, X, Y, HP1, HLL1, A1), vuelo(Z2, Y, X, HP2, HLL2, A2), write(X), write(' y '),write(Y),nl, fail.



